//Riot Shield
//Script by Jetz. Original shield script by Space Guy. Original Health kit mounting script by Rotondo.

datablock AudioProfile(RiotShieldBounceSound) //Played when we deflect something.
{
	filename    = "./bhit_helmet-1.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(RiotShieldPlantSound) //Played when we Plant the shield in the ground.
{
	filename    = "./blade_cut.wav";
	description = AudioClosest3d;
	preload = true;
};

datablock AudioProfile(RiotShieldPullSound) //Played when we pull the shield from the ground.
{
	filename    = "./blade_in.wav";
	description = AudioClosest3d;
	preload = true;
};

if(!isObject(HomerunBatHitSound)) //Beacuse it's exactly the same and creating a new one is a wase of datablocks.
{
	datablock AudioProfile(HomerunBatHitSound) //used when we bash something with the shield.
	{
		filename		= "./BatHit.wav";
		description		= AudioClosest3d;
		preload			= true;
	};
}

if(!isObject(swordExplosionParticle)) //I can't imagine how creating a datablock exactly the same as the default one could mess something up, but this should save the modified ones.
{
	datablock ParticleData(swordExplosionParticle) //A bash explosion doesn't need to be fancy.
	{
		dragCoefficient			= 2;
		gravityCoefficient		= 1.0;
		inheritedVelFactor		= 0.2;
		constantAcceleration	= 0.0;
		
		spinRandomMin			= -90;
		spinRandomMax			= 90;
		
		lifetimeMS			 	= 500;
		lifetimeVarianceMS		= 300;
		
		textureName				= "base/data/particles/chunk";
		
		colors[0]				= "0.7 0.7 0.9 0.9";
		colors[1]				= "0.9 0.9 0.9 0.0";
		sizes[0]				= 0.5;
		sizes[1]				= 0.25;
	};
	
	datablock ParticleEmitterData(swordExplosionEmitter)
	{
		ejectionPeriodMS	= 7;
		periodVarianceMS	= 0;
		ejectionVelocity	= 8;
		velocityVariance	= 1.0;
		ejectionOffset		= 0.0;
		thetaMin			= 0;
		thetaMax			= 60;
		phiReferenceVel		= 0;
		phiVariance			= 360;
		
		overrideAdvance		= false;
		
		particles			= "swordExplosionParticle";

		uiName				= "Sword Hit";
	};
}

datablock ExplosionData(RiotShieldExplosion) //For when we use the melee bash.
{
	lifeTimeMS			= 500;
	impulseRadius		= 2; //So we can knock back more than one thing at a time if they're that close together. Most likely use is against zombies.
	impulseForce		= 1700;
	damageRadius		= 2; //For some reason setting damage or damage radius to 0 stops the impulse. Probably caused by impulse being scaled by damage or something.
	radiusDamage		= 0.1;

	soundProfile		= HomerunBatHitSound;

	particleEmitter		= SwordExplosionEmitter;
	particleDensity		= 10;
	particleRadius		= 0.2;

	faceViewer			= true;
	explosionScale		= "1 1 1";

	shakeCamera			= true;
	camShakeFreq		= "20.0 22.0 20.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 10.0;

	lightStartRadius	= 3;
	lightEndRadius		= 0;
	lightStartColor		= "1 0.85 0.7";
	lightEndColor		= "0 0 0";
};


datablock ProjectileData(RiotShieldMeleeProjectile)
{
	directDamage		= 5;
	explosion			= RiotShieldExplosion;
	verticalImpulse		= 1200; //So the target is launched into the air to keep them from catching on the ground immediately.

	muzzleVelocity		= 50;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 100;
	fadeDelay			= 70;
   
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;

	hasLight			= false;
	lightRadius			= 3.0;
	lightColor			= "0 0 0.5";
};

datablock ItemData(RiotShieldItem)
{
	category		= "Weapon";
	className		= "Weapon";

	shapeFile		= "./RiotShield.dts";
	rotate			= false;
	mass			= 1;
	density			= 0.2;
	elasticity		= 0.2;
	friction		= 0.6;
	emap			= true;

	uiName			= "Riot Shield";
	iconName		= "./RiotShield";
	doColorShift	= false;

	image			= RiotShieldImage;
	canDrop			= true;
};

datablock ShapeBaseImageData(RiotShieldImage)
{
	shapeFile						= "./RiotShield.dts";
	emap							= true;

	mountPoint						= 0;
	offset							= "0 0 0";
	eyeOffset						= 0;
	rotation						= eulerToMatrix( "0 0 0" );
	scale							= "3 3 3";
	correctMuzzleVector				= true;

	className						= "WeaponImage";
	item							= " ";
	ammo							= " ";
	projectile						= "RiotShieldMeleeProjectile";
	projectileType					= "Projectile";

	melee							= false;
	armReady						= true;

	doColorShift					= false;
	colorShiftColor					= "0.196 0.196 0.196 0.5";

	stateName[0]					= "Activate";
	stateTimeoutValue[0]			= 0.5;
	stateTransitionOnTimeout[0]		= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "PreFire";
	stateAllowImageChange[1]		= true;

	stateName[2]					= "PreFire";
	stateScript[2]					= "onPreFire";
	stateAllowImageChange[2]		= false;
	stateTimeoutValue[2]			= 0.1;
	stateTransitionOnTimeout[2]		= "Fire";

	stateName[3]					= "Fire";
	stateTransitionOnTimeout[3]		= "Ready";
	stateTimeoutValue[3]			= 0.4;
	stateFire[3]					= true;
	stateAllowImageChange[3]		= false;
	stateSequence[3]				= "Fire";
	stateScript[3]					= "onFire";
	stateWaitForTimeout[3]			= true;
};

function RiotShieldImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, activate); //A suitable animation.
}

datablock ShapeBaseImageData(RiotShieldBackImage) //An alternate image to be mounted on their back.
{
	shapeFile				= "./RiotShield.dts";
	emap					= true;

	mountPoint				= 7; //On their back.
	offset					= "-0.5 -0.45 0.95";
	eyeOffset				= "0 9999 0"; //Nothing to see in first person here.
	rotation				= eulerToMatrix( "0 0 180" );
	scale					= "3 3 3";
	correctMuzzleVector		= true;

	className				= "WeaponImage";
	firstPerson				= 0;

	doColorShift			= false;
	colorShiftColor			= "0.196 0.196 0.196 0.5";
};

datablock staticshapedata(RiotShieldGround)
{
	shapefile = "./riotshieldground.dts";
	isInvincible	= 1;
};

package RiotShield //All the crazy script changes.
{
	function ProjectileData::damage(%this,%obj,%col,%fade,%pos,%normal) //Blocking damage. Original script by Space Guy. I've gutted out a few major bits and added in my own.
	{
		for(%i=0;%i<%col.getDatablock().maxTools;%i++) //A loop through the inventory to see if they have a shield.
		{
			%item = %col.tool[%i];
			if(%item == RiotShieldItem.getID() && %i != %col.currtool) //And to confirm that it is not in use so we can say there is a shield on their back.
			{
				%BackShield = 1;
				break;
			}
		}
		if(!(%col.getType() & $TypeMasks::PlayerObjectType) || (%col.getMountedImage(0) != RiotShieldimage.getID() && !%BackShield)) //If they aren't holding a shield or carrying one on their back...
		{
			Parent::damage(%this,%obj,%col,%fade,%pos,%normal); //Play it normally and leave.
			return;
		}
		
		else
		{
			%aimVec = %col.getForwardVector();
			%reflect = ((vectorDot(vectorNormalize(%obj.getVelocity()),%aimVec) < 0 && %col.getMountedImage(0) == RiotShieldimage.getID()) || (vectorDot(vectorScale(vectorNormalize(%obj.getVelocity()), -1),%aimVec) < 0 && %backShield)); //If the shield is facing the projectile...
         
			if(!%reflect)
			{
				Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
				return;
			}
			else
				serverPlay3d(RiotShieldBounceSound,%pos); //Play a sound.
		}
	}

	function ShapeBase::Damage(%this, %source, %pos, %amount, %type) //Stops zombies and their unholy powers of collision damage.
	{
		if(%source.isZombie)
		{
			for(%i=0;%i<%this.getDatablock().maxTools;%i++)
			{
				%item = %this.tool[%i];
				if(%item == RiotShieldItem.getID() && %i != %this.currtool)
				{
					%BackShield = 1;
					break;
				}
			}
			%sVec = %source.getForwardVector();
			%aimVec = %this.getForwardVector();
			if(!(%this.getType() & $TypeMasks::PlayerObjectType) || (%this.getMountedImage(0) != RiotShieldimage.getID() && !%BackShield))
			{
				Parent::damage(%this, %source, %pos, %amount, %type);
				return;
			}
			%reflect = ((vectorDot(%sVec, %aimVec) < 0 && %this.getMountedImage(0) == RiotShieldimage.getID()) || (vectorDot(vectorScale(%sVec, -1), %aimVec) < 0 && %backShield));
			if(%reflect)
			{
				serverPlay3d(RiotShieldBounceSound,%pos);
				return;
			}
		}
		Parent::damage(%this, %source, %pos, %amount, %type);
	}

	function ProjectileData::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt)
	{
		for(%i=0;%i<%col.getDatablock().maxTools;%i++) //A loop through the inventory to see if they have a shield.
		{
			%item = %col.tool[%i];
			if(%item == RiotShieldItem.getID() && %i != %col.currtool) //And to confirm that it is not in use so we can say there is a shield on their back.
			{
				%BackShield = 1;
				break;
			}
		}
		if(!(%col.getType() & $TypeMasks::PlayerObjectType) || (%col.getMountedImage(0) != RiotShieldimage.getID() && !%BackShield)) //If they aren't holding a shield or carrying one on their back...
		{
			Parent::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt); //Play it normally and leave.
			return;
		}
		
		else
		{
			%aimVec = %col.getForwardVector();
			%reflect = ((vectorDot(vectorNormalize(%obj.getVelocity()),%aimVec) < 0 && %col.getMountedImage(0) == RiotShieldimage.getID()) || (vectorDot(vectorScale(vectorNormalize(%obj.getVelocity()), -1),%aimVec) < 0 && %backShield)); //If the shield is facing the projectile...
         
			if(!%reflect)
			{
				Parent::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt);
				return;
			}
			else
			{
				serverPlay3d(RiotShieldBounceSound,%pos); //play a sound.
				return;
			}
		}
		%shield = containerRayCast(%pos, %col.getTransform(), $typemasks::StaticShapeObjectType); //Also making it so explosions don't go through static shapes, like the dropped shield.
		if(isObject(%shield))
			return;
		Parent::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt);
	}
	
	function ProjectileData::radiusImpulse(%this, %obj, %col, %distanceFactor, %pos, %impulseAmt, %un) //No idea what %un[known] is. Badspot should post more functions like he did with the damage ones.
	{
				for(%i=0;%i<%col.getDatablock().maxTools;%i++) //A loop through the inventory to see if they have a shield.
		{
			%item = %col.tool[%i];
			if(%item == RiotShieldItem.getID() && %i != %col.currtool) //And to confirm that it is not in use so we can say there is a shield on their back.
			{
				%BackShield = 1;
				break;
			}
		}
		if(!(%col.getType() & $TypeMasks::PlayerObjectType) || (%col.getMountedImage(0) != RiotShieldimage.getID() && !%BackShield)) //If they aren't holding a shield or carrying one on their back...
		{

			Parent::radiusImpulse(%this, %obj, %col, %distanceFactor, %pos, %impulseAmt, %un); //Play it normally and leave.
			return;
		}
		
		else
		{
			%aimVec = %col.getForwardVector();
			%boomVec = vectorsub(%col.gettransform(), %pos);
			%reflect = ((vectorDot(vectorNormalize(%boomvec),%aimVec) < 0 && %col.getMountedImage(0) == RiotShieldimage.getID()) || (vectorDot(vectorScale(vectorNormalize(%Boomvec), -1),%aimVec) < 0 && %backShield)); //If the shield is facing the projectile...
         
			if(!%reflect)
			{
				Parent::radiusImpulse(%this, %obj, %col, %distanceFactor, %pos, %impulseAmt, %un);
				return;
			}
			else
			{
				serverPlay3d(RiotShieldBounceSound,%pos); //play a sound.
				%impulseAmt /= 3; //And nerf the impulse, still doing some.
			}
		}
		%shield = containerRayCast(%pos, %col.getTransform(), $typemasks::StaticShapeObjectType); //Also making it so explosions don't go through static shapes, like the dropped shield.
		if(isObject(%shield))
			return;
		Parent::radiusImpulse(%this, %obj, %col, %distanceFactor, %pos, %impulseAmt, %un);
	}
	
	function RiotShieldImage::onUnMount(%this, %obj, %slot)
	{
		Parent::onUnMount(%this, %obj, %slot);
		for(%i=0;%i<%obj.getDatablock().maxTools;%i++) //Make sure we haven't dropped it.
		{
			%item = %obj.tool[%i];
			if(%item == RiotShieldItem.getID() && %i != %obj.currtool)
			{
				%obj.mountimage(RiotShieldBackImage, 2); //Put it on our back.
				break;
			}
		}
	}
	function RiotShieldImage::onMount(%this, %obj, %slot)
	{
		Parent::onMount(%this, %obj, %slot);
		%obj.unmountimage(2); //Get it off our back.
	}
	function RiotShieldItem::onPickup(%this, %obj, %col, %a)
	{
		parent::onPickup(%this, %obj, %col, %a);
		for(%i=0;%i<%col.getDatablock().maxTools;%i++) //To ensure they actually picked it up.
		{
			%item = %col.tool[%i];
			if(%item == RiotShieldItem.getID() && %i != %col.currtool)
			{
				%col.mountimage(RiotShieldBackImage,2);
				break;
			}
		}
	}
	
	function armor::onTrigger(%this, %obj, %triggerNum, %val) //A combination of the jet-altfire and my own script to create two separate parts of the same feature.
	{
		if(%triggernum $= 4 && %obj.getMountedImage(0) $= RiotShieldImage.getID())
		{
			if(%val)
			{
				%obj.RiotShieldAltFireTime = getSimTime();
			}
			else
			{
				if(vectorDist(%obj.RiotShieldAltFireTime, getSimTime()) < 500)
				{
					if(%obj.Tool[%obj.currTool] == RiotShieldItem.getId() && !isObject(%obj.client.Shield))
					{
						%client = %obj.client;
						%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 5), %client.player.getEyePoint()), ($typeMasks::InteriorObjectType | $typeMasks::FxBrickObjectType | $typeMasks::TerrainObjectType));
						if(isObject(%target))
						{
							%hitpos = getwords(%target, 1, 3);
							%obj.tool[%obj.currTool] = 0;
							%obj.weaponCount--;
							messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,0);
							serverCmdUnUseTool(%obj.client);
							%StaticShield = new StaticShape()
							{
								datablock = RiotShieldGround;
								owner = %client;
							};
							missionCleanup.add(%StaticShield);
							%staticShield.setTransform(vectorAdd(%Hitpos, "0 0 1.15") SPC getWords(%obj.GetTransform(),3,6));
							%client.shield = %staticshield;
							%staticShield.setScale(getWord(%obj.getScale(),2) SPC getWord(%obj.getScale(),2) SPC getWord(%obj.getScale(),2));
							%staticShield.schedule(120000, delete);
							serverPlay3d(RiotShieldPlantSound, %Hitpos);
						}
					}
				}	
			}
		}
		else
		{
			Parent::onTrigger(%this,%obj,%triggerNum,%val);
			if(%triggernum $= 0 && !isObject(%obj.getMountedImage(0)))
			{
				if(%val)
				{
					%client = %obj.client;
					%target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 2), %client.player.getEyePoint()), $typeMasks::StaticShapeObjectType);
					if(isObject(%target))
					{
						if(%target.getDatablock() == RiotShieldGround.getID())
						{
							%pos = %target.getTransform();
							%blid = (isObject(%client.minigame) ? %client.minigame.owner.bl_id : %client.bl_id);
							%ItemShield = new Item()
							{
								datablock = RiotShieldItem;
								static = false;
								bl_id = %blid;
							};
							missionCleanup.add(%ItemShield);
							%itemShield.SchedulePop();
							%itemShield.setTransform(vectorAdd(%pos, "0 0 2"));
							%target.delete();
							serverPlay3d(RiotShieldPullSound, %pos);
						}
					}
				}
			}
		}
	}
};
activatepackage(RiotShield);